## pyenv 2.5.4

=== Makefile ===
.PHONY: test test-build test-unit test-plugin

# Do not pass in user flags to build tests.
unexport PYTHON_CFLAGS
unexport PYTHON_CONFIGURE_OPTS

test: test-unit test-plugin

test-unit: bats
	PATH="./bats/bin:$$PATH" test/run
	
test-plugin: bats
	cd plugins/python-build && $(PWD)/bats/bin/bats $${CI:+--tap} test

PYTHON_BUILD_ROOT := $(CURDIR)/plugins/python-build
PYTHON_BUILD_OPTS ?= --verbose
PYTHON_BUILD_VERSION ?= 3.8-dev
PYTHON_BUILD_TEST_PREFIX ?= $(PYTHON_BUILD_ROOT)/test/build/tmp/dist

test-build:
	$(RM) -r $(PYTHON_BUILD_TEST_PREFIX)
	$(PYTHON_BUILD_ROOT)/bin/python-build $(PYTHON_BUILD_OPTS) $(PYTHON_BUILD_VERSION) $(PYTHON_BUILD_TEST_PREFIX)
	[ -e $(PYTHON_BUILD_TEST_PREFIX)/bin/python ]
	$(PYTHON_BUILD_TEST_PREFIX)/bin/python -V
	[ -e $(PYTHON_BUILD_TEST_PREFIX)/bin/pip ]
	$(PYTHON_BUILD_TEST_PREFIX)/bin/pip -V

bats:
	git clone --depth 1 --branch v1.2.0 https://github.com/bats-core/bats-core.git bats

=== debian/changelog ===
pyenv (2.5.4-1) unstable; urgency=medium

  * Team Upload
  * d/control: Bump Standards-Version to 4.7.2
  * d/gbp.conf: Add a basic configuration
  * New upstream version 2.5.4

 -- Carsten Schoenert <c.schoenert@t-online.de>  Tue, 01 Apr 2025 17:29:49 +0200

pyenv (2.5.1-1) unstable; urgency=medium

  [ Josenilson Ferreira da Silva ]
  * Initial release. (Closes: #978149)

  [ Dmitry Shachnev ]
  * Improve the man pages.
  * Install the bash-completion file in the right location.
  * Make the package “Architecture: all”.

 -- Josenilson Ferreira da Silva <nilsonfsilva@hotmail.com>  Tue, 04 Feb 2025 21:21:09 -0300

=== debian/control ===
Source: pyenv
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Josenilson Ferreira da Silva <nilsonfsilva@hotmail.com>, karthek <mail@karthek.com>
Rules-Requires-Root: no
Build-Depends: bash (>= 5.0),
               bats,
               debhelper-compat (= 13),
               dh-sequence-bash-completion,
               dh-sequence-python3,
               git <!nocheck>,
               python3-all
Standards-Version: 4.7.2
Homepage: https://github.com/pyenv/pyenv
Vcs-Browser: https://salsa.debian.org/python-team/packages/pyenv
Vcs-Git: https://salsa.debian.org/python-team/packages/pyenv.git

Package: pyenv
Architecture: all
Depends: ${misc:Depends},
         ${python3:Depends},
         build-essential,
         curl,
         expat,
         libauthen-sasl-perl,
         libbz2-dev,
         libcgi-pm-perl,
         liberror-perl,
         libffi-dev,
         libio-socket-ssl-perl,
         liblwp-protocol-https-perl,
         liblzma-dev,
         libmediawiki-api-perl,
         libncurses-dev,
         libreadline-dev,
         libsqlite3-dev,
         libssl-dev,
         libterm-readkey-perl,
         libwww-perl,
         libxml2-dev,
         libxmlsec1-dev,
         llvm,
         make,
         pcre2-utils,
         python3:any,
         tk-dev,
         wget,
         xz-utils,
         zlib1g-dev,
Suggests: git,
          python3-openssl,
          python3-requests,
          python3-tk-dbg,
          libsecret-1-dev
Description: Simple Python version management
 pyenv is a powerful and flexible tool for managing multiple Python versions
 on a single system. It allows users to seamlessly switch between different
 Python versions, making it ideal for developers working on projects with
 varying dependencies.
 .
 Key features of pyenv include:
  - Version switching: Dynamically change the active Python version globally,
     per user, or for specific directories.
  - Version installation: Easily install and manage multiple Python versions,
     including older releases, latest updates, and development builds.
  - Environment isolation: Create isolated Python environments for different
     projects without polluting the global environment.
  - Compatibility: Works alongside system Python installations, ensuring no
     interference with package managers like apt or dnf.
  - Pluggable architecture: Extend functionality with plugins, such as
     pyenv-virtualenv for virtual environments

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export PYBUILD_NAME=pyenv
export PYENV_SHELL=bash
export SHELL=/bin/bash

export CFLAGS=${CFLAGS:-""}
export CPPFLAGS=${CPPFLAGS:-""}
export LDFLAGS=${LDFLAGS:-""}

%:
	dh $@
override_dh_auto_install:
# Set pyenv variables
	export PYENV_ROOT=/home/user/.pyenv
	export PATH=$(PYENV_ROOT)/bin:$(PATH)
	eval "$(pyenv init --path)"
	eval "$(pyenv init -)"
# Create the directory to install the binaries
	mkdir -p debian/pyenv/usr/bin/
	mkdir -p debian/pyenv/usr/share/bash-completion/completions/

execute_after_dh_install:
	find debian/pyenv/usr/share/pyenv/plugins/  \
	-name 'README.md' -delete \
	-o -name '.gitignore' -delete \
	-o -name 'LICENSE' -delete \
	-o -name 'requirements.txt' -delete
	find debian/pyenv/usr/share/pyenv/plugins/python-build/  \
	-type d -empty -exec rmdir {} +

=== debian/watch ===
version=4
https://github.com/pyenv/pyenv/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@

## pyenv 2.5.5

=== debian/changelog ===
pyenv (2.5.5-2) unstable; urgency=medium

  *Upload to ustable

 -- Josenilson Ferreira da Silva <nilsonfsilva@hotmail.com>  Fri, 19 Sep 2025 14:53:25 -0300

pyenv (2.5.5-1) experimental; urgency=medium

  * New upstream version 2.5.5
  * debian/control:
     - Added binary with simple components for runtime (Closes: #1103905)
     - Added Breaks/Replaces for pyenv-runtime
     - Updated list of required dependencies
  * debian/copyright:
     - Updated GPL2 license terms
  * debian/patches:
     - 004.fixed-line-break.patch: Removed pyenv.1 file
     - 006.change-shell-to-fix-test.patch: Fixed hunk issue
     - 007.fixed-command-manpage.patch: Fix command  bashrc (Closes: #1102884)
     - 008.added-pyenv-runtime-information.patch: Add information pyenv-runtime
  * debian/pyenv.install:
     - Specified pyenv binary package files
  * debian/pyenv.links:
     - Removed pyenv binary link
  * debian/pyenv.manpages:
     - Removed pyenv manpage
  * debian/pyenv-runtime.instal:
     - Added components to pyenv-runtime binary
  * debian/pyenv-runtime.links:
     - Created pyenv symbolic link
  * debian/pyenv-runtime.manpages:
     - Linked pyenv manpage to pyenv-runtime binary
  * debian/pyenv.sh:
     - Removed unnecessary wrapper
  * debian/rules:
     - Adjustments for correct construction of binaries
     - Fixed variable declaration

 -- Josenilson Ferreira da Silva <nilsonfsilva@hotmail.com>  Fri, 02 May 2025 21:05:39 -0300

=== debian/rules ===
--- 
+++ 
@@ -11,16 +11,23 @@
 %:
 	dh $@
 override_dh_auto_install:
+# Create the directory to install the binaries
+	mkdir -p debian/pyenv-runtime/usr/bin/
+	mkdir -p debian/pyenv-runtime/usr/share/pyenv/libexec/
+	mkdir -p debian/pyenv/usr/share/pyenv/pyenv.d/
+	mkdir -p debian/pyenv/usr/share/pyenv/libexec/
+
 # Set pyenv variables
-	export PYENV_ROOT=/home/user/.pyenv
-	export PATH=$(PYENV_ROOT)/bin:$(PATH)
-	eval "$(pyenv init --path)"
-	eval "$(pyenv init -)"
-# Create the directory to install the binaries
-	mkdir -p debian/pyenv/usr/bin/
-	mkdir -p debian/pyenv/usr/share/bash-completion/completions/
+	printf '%s\n' \
+		'#!/bin/bash' \
+		'export PYENV_ROOT="/usr/share/pyenv"' \
+		'export PATH="$$PYENV_ROOT/bin:$$PYENV_ROOT/libexec:$$PATH"' \
+		'exec pyenv "$$@"' \
+		> debian/pyenv-runtime/usr/bin/pyenv
+	chmod 755 debian/pyenv-runtime/usr/bin/pyenv
 
 execute_after_dh_install:
+	find debian/pyenv/ -name ".gitignore" -delete
 	find debian/pyenv/usr/share/pyenv/plugins/  \
 	-name 'README.md' -delete \
 	-o -name '.gitignore' -delete \

## pyenv 2.6.8

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,86 @@
+TEST_BATS_VERSION = v1.10.0
+TEST_BASH_VERSIONS = 3.2.57 4.1.17
+TEST_UNIT_DOCKER_PREFIX = test-unit-docker
+TEST_UNIT_DOCKER_TARGETS = $(foreach bash,$(TEST_BASH_VERSIONS),$(addsuffix -$(bash),$(TEST_UNIT_DOCKER_PREFIX)) $(addsuffix -gnu-$(bash),$(TEST_UNIT_DOCKER_PREFIX)))
+TEST_PLUGIN_DOCKER_PREFIX = test-plugin-docker
+TEST_PLUGIN_DOCKER_TARGETS = $(foreach bash,$(TEST_BASH_VERSIONS),$(addsuffix -$(bash),$(TEST_PLUGIN_DOCKER_PREFIX)) $(addsuffix -gnu-$(bash),$(TEST_PLUGIN_DOCKER_PREFIX)))
+TEST_BATS_IMAGE_PREFIX = test-pyenv-docker-image
+TEST_BATS_IMAGE_TARGETS = $(foreach bash,$(TEST_BASH_VERSIONS),$(addsuffix -$(bash),$(TEST_BATS_IMAGE_PREFIX)) $(addsuffix -gnu-$(bash),$(TEST_BATS_IMAGE_PREFIX)))
+
+.PHONY:
+test-docker: $(TEST_UNIT_DOCKER_PREFIX) $(TEST_PLUGIN_DOCKER_PREFIX)
+
+# Run all unit test under bats docker
+.PHONY: $(TEST_UNIT_DOCKER_PREFIX)
+$(TEST_UNIT_DOCKER_PREFIX): $(TEST_UNIT_DOCKER_TARGETS)
+
+# Run each unit test under bats docker
+.PHONY: $(TEST_UNIT_DOCKER_TARGETS)
+$(TEST_UNIT_DOCKER_TARGETS): DOCKER_IMAGE = $(TEST_BATS_IMAGE_PREFIX)
+$(TEST_UNIT_DOCKER_TARGETS): GNU = $(if $(findstring -gnu-,$@),True,False)
+$(TEST_UNIT_DOCKER_TARGETS): BASH = $(filter $(TEST_BASH_VERSIONS),$(subst -, ,$@))
+$(TEST_UNIT_DOCKER_TARGETS): DOCKER_TAG = bash-$(BASH)-gnu-$(GNU)
+$(TEST_UNIT_DOCKER_TARGETS): INTERACTIVE = $(if $(findstring true,$(CI)),,-ti)
+$(TEST_UNIT_DOCKER_TARGETS): $(TEST_UNIT_DOCKER_PREFIX)-% : $(TEST_BATS_IMAGE_PREFIX)-%
+	$(info Running test with docker image '$(DOCKER_IMAGE):$(DOCKER_TAG)')
+	docker run \
+		--init \
+		-v $(PWD):/code:ro \
+		-v /etc/passwd:/etc/passwd:ro \
+		-v /etc/group:/etc/group:ro \
+		-u "$$(id -u $$(whoami)):$$(id -g $$(whoami))" \
+		$${BATS_TEST_FILTER:+-e BATS_TEST_FILTER="$${BATS_TEST_FILTER}"} \
+		$${BATS_FILE_FILTER:+-e BATS_FILE_FILTER="$${BATS_FILE_FILTER}"} \
+	        $${CI+-e CI="$${CI}"} \
+	        $(INTERACTIVE) \
+		$(DOCKER_IMAGE):$(DOCKER_TAG) \
+		test/run
+
+# Run all plugin test under bats docker
+.PHONY: $(TEST_PLUGIN_DOCKER_PREFIX)
+$(TEST_PLUGIN_DOCKER_PREFIX): $(TEST_PLUGIN_DOCKER_TARGETS)
+
+# Run each plugin test under bats docker
+.PHONY: $(TEST_PLUGIN_DOCKER_TARGETS)
+$(TEST_PLUGIN_DOCKER_TARGETS): DOCKER_IMAGE = $(TEST_BATS_IMAGE_PREFIX)
+$(TEST_PLUGIN_DOCKER_TARGETS): GNU = $(if $(findstring -gnu-,$@),True,False)
+$(TEST_PLUGIN_DOCKER_TARGETS): BASH = $(filter $(TEST_BASH_VERSIONS),$(subst -, ,$@))
+$(TEST_PLUGIN_DOCKER_TARGETS): DOCKER_TAG = bash-$(BASH)-gnu-$(GNU)
+$(TEST_PLUGIN_DOCKER_TARGETS): INTERACTIVE = $(if $(findstring true,$(CI)),,-ti)
+$(TEST_PLUGIN_DOCKER_TARGETS): $(TEST_PLUGIN_DOCKER_PREFIX)-% : $(TEST_BATS_IMAGE_PREFIX)-%
+	$(info Running test with docker image '$(DOCKER_IMAGE):$(DOCKER_TAG)')
+	docker run \
+		--init \
+		-v $(PWD):/code:ro \
+		-v /etc/passwd:/etc/passwd:ro \
+		-v /etc/group:/etc/group:ro \
+		-u "$$(id -u $$(whoami)):$$(id -g $$(whoami))" \
+	        $${CI+-e CI="$${CI}"} \
+	        $(INTERACTIVE) \
+		$(DOCKER_IMAGE):$(DOCKER_TAG) \
+		bats $${BATS_TEST_FILTER:+--filter "$${BATS_TEST_FILTER}"} plugins/python-build/test/$${BATS_FILE_FILTER}
+
+# Build all images needed for bats under docker
+.PHONY: $(TEST_BATS_IMAGE_PREFIX)
+$(TEST_BATS_IMAGE_PREFIX): $(TEST_BATS_IMAGE_TARGETS)
+
+# Build each image needed for bats under docker
+.PHONY: $(TEST_BATS_IMAGE_TARGETS)
+$(TEST_BATS_IMAGE_TARGETS): DOCKER_IMAGE = $(TEST_BATS_IMAGE_PREFIX)
+$(TEST_BATS_IMAGE_TARGETS): GNU = $(if $(findstring -gnu-,$@),True,False)
+$(TEST_BATS_IMAGE_TARGETS): BASH = $(filter $(TEST_BASH_VERSIONS),$(subst -, ,$@))
+$(TEST_BATS_IMAGE_TARGETS): DOCKER_TAG = bash-$(BASH)-gnu-$(GNU)
+$(TEST_BATS_IMAGE_TARGETS):
+	$(info Building docker image '$(DOCKER_IMAGE):$(DOCKER_TAG)')
+	docker build \
+		--quiet \
+		-f "$(PWD)/test/Dockerfile" \
+		--build-arg GNU="$(GNU)" \
+		--build-arg BASH="$(BASH)" \
+		--build-arg BATS_VERSION="$(TEST_BATS_VERSION)" \
+		-t $(DOCKER_IMAGE):$(DOCKER_TAG) \
+		./
+
 .PHONY: test test-build test-unit test-plugin
 
 # Do not pass in user flags to build tests.
@@ -10,7 +93,7 @@
 	PATH="./bats/bin:$$PATH" test/run
 	
 test-plugin: bats
-	cd plugins/python-build && $(PWD)/bats/bin/bats $${CI:+--tap} test
+	cd plugins/python-build && $(PWD)/bats/bin/bats $${CI:+--tap} $${BATS_TEST_FILTER:+--filter "$${BATS_TEST_FILTER}"} test/$${BATS_FILE_FILTER}
 
 PYTHON_BUILD_ROOT := $(CURDIR)/plugins/python-build
 PYTHON_BUILD_OPTS ?= --verbose
@@ -25,5 +108,12 @@
 	[ -e $(PYTHON_BUILD_TEST_PREFIX)/bin/pip ]
 	$(PYTHON_BUILD_TEST_PREFIX)/bin/pip -V
 
-bats:
-	git clone --depth 1 --branch v1.2.0 https://github.com/bats-core/bats-core.git bats
+.SECONDARY: bats-$(TEST_BATS_VERSION)
+bats-$(TEST_BATS_VERSION):
+	rm -rf bats
+	ln -sf bats-$(TEST_BATS_VERSION) bats
+	git clone --depth 1 --branch $(TEST_BATS_VERSION) https://github.com/bats-core/bats-core.git bats-$(TEST_BATS_VERSION)
+
+.PHONY: bats
+bats: bats-$(TEST_BATS_VERSION)
+	ln -sf bats-$(TEST_BATS_VERSION) bats

=== plugins/python-build/scripts/requirements.txt ===
requests-html

=== debian/changelog ===
pyenv (2.6.8-1) unstable; urgency=medium

  * New upstream version 2.6.8
  * debian/clean: Added build artifacts
  * debian/patches:
     - 001.use-local-bats-repository.patch: Fixed in the new version
     - 002.skip-tests-with-test-directory-error.patch: Added skipped tests
     - 003.skip-tests-with-plugin-directory-error.patch: Added skipped tests
     - 005.fixed-error-sintaxe-bash.patch: Tweaks package detection and build
     - 004.fixed-line-break.patch: Fixed in the new version
     - 007.fixed-command-manpage.patch: update pyenv .bashrc(Closes: #1102884)
     - 008.added-pyenv-runtime-information.patch: Updated patch
     - 009.disable-docker-tests.patch: Skipping docker test run
  * debian/rules: Adjustments for running non-docker tests
  * debian/watch: Bumped version to 5


 -- Josenilson Ferreira da Silva <nilsonfsilva@hotmail.com>  Tue, 23 Sep 2025 21:11:20 -0300

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,14 @@
 Section: python
 Priority: optional
 Maintainer: Debian Python Team <team+python@tracker.debian.org>
-Uploaders: Josenilson Ferreira da Silva <nilsonfsilva@hotmail.com>, karthek <mail@karthek.com>
+Uploaders: Josenilson Ferreira da Silva <nilsonfsilva@hotmail.com>,
+           karthek <mail@karthek.com>
 Rules-Requires-Root: no
-Build-Depends: bash (>= 5.0),
-               bats,
-               debhelper-compat (= 13),
+Build-Depends: debhelper-compat (= 13),
                dh-sequence-bash-completion,
                dh-sequence-python3,
+               bash (>= 5.0),
+               bats,
                git <!nocheck>,
                python3-all
 Standards-Version: 4.7.2
@@ -16,43 +17,50 @@
 Vcs-Browser: https://salsa.debian.org/python-team/packages/pyenv
 Vcs-Git: https://salsa.debian.org/python-team/packages/pyenv.git
 
+Package: pyenv-runtime
+Breaks: pyenv (<< ${binary:Version})
+Replaces: pyenv (<< ${binary:Version})
+Architecture: all
+Depends: bash (>= 5.0),
+         ${misc:Depends},
+Description: Simple Python version management (runtime components)
+ Pyenv lets you easily switch between multiple versions of Python.
+ pyenv-runtime allows minimal execution of pyenv in shared environments
+ (e.g. HPC clusters). pyenv-runtime only allows execution of pyenv shims
+ on worker hosts. While the full pyenv package (with dependencies) is
+ installed only on the management host.
+ .
+ Ideal for setups where /home is shared via NFS and users need consistent
+ Python version selection across nodes. The purpose of this split is to
+ allow pyev-runtime to be used for shared environments (HPC/NFS), running
+ only to run shims. While full pyenv (with install/local) for management
+ on the master node.
+
 Package: pyenv
 Architecture: all
 Depends: ${misc:Depends},
-         ${python3:Depends},
+         ${shlibs:Depends},
+         pyenv-runtime (= ${binary:Version}),
          build-essential,
          curl,
-         expat,
-         libauthen-sasl-perl,
          libbz2-dev,
-         libcgi-pm-perl,
-         liberror-perl,
          libffi-dev,
-         libio-socket-ssl-perl,
-         liblwp-protocol-https-perl,
          liblzma-dev,
-         libmediawiki-api-perl,
          libncurses-dev,
          libreadline-dev,
          libsqlite3-dev,
          libssl-dev,
-         libterm-readkey-perl,
-         libwww-perl,
          libxml2-dev,
          libxmlsec1-dev,
-         llvm,
          make,
-         pcre2-utils,
          python3:any,
-         tk-dev,
          wget,
          xz-utils,
          zlib1g-dev,
-Suggests: git,
-          python3-openssl,
-          python3-requests,
-          python3-tk-dbg,
-          libsecret-1-dev
+Recommends: git,
+            llvm,
+            tk-dev
+Suggests: libsecret-1-dev,
 Description: Simple Python version management
  pyenv is a powerful and flexible tool for managing multiple Python versions
  on a single system. It allows users to seamlessly switch between different

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,9 @@
 export CFLAGS=${CFLAGS:-""}
 export CPPFLAGS=${CPPFLAGS:-""}
 export LDFLAGS=${LDFLAGS:-""}
+
+export BATS_SKIP_VERSION_TESTS=1
+export BATS_BIN=/usr/bin/bats
 
 %:
 	dh $@
@@ -26,6 +29,9 @@
 		> debian/pyenv-runtime/usr/bin/pyenv
 	chmod 755 debian/pyenv-runtime/usr/bin/pyenv
 
+override_dh_auto_build:
+	$(MAKE) PYENV_SKIP_DOCKER=1
+
 execute_after_dh_install:
 	find debian/pyenv/ -name ".gitignore" -delete
 	find debian/pyenv/usr/share/pyenv/plugins/  \

=== debian/watch ===
version=5
https://github.com/pyenv/pyenv/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@
